//
//  SepiaView.m
//  CoreImageFilters
//
//  Created by Kevin Hoffman on 9/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "SepiaView.h"
#import <QuartzCore/QuartzCore.h>

@implementation SepiaView

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)drawRect:(NSRect)dirtyRect
{
    // Drawing code here.
    NSArray *filterNames = [CIFilter filterNamesInCategory:kCICategoryColorEffect];
    for (NSString *filterName in filterNames)
    {
        NSLog(@"filter: %@", filterName);
    }
    
    // load attributes for the CISepiaTone filter
    CIFilter *sepiaFilter;
    NSDictionary *filterAttributes;
    sepiaFilter = [CIFilter filterWithName:@"CISepiaTone"];
    filterAttributes = [sepiaFilter attributes];
    NSLog(@"sepia attributes: %@", filterAttributes);
    
    CIContext *context = [CIContext contextWithCGContext:[[NSGraphicsContext currentContext] graphicsPort] options:nil];
    NSString *imagepath = [[NSBundle mainBundle] pathForImageResource:@"palmtree"];
    CIImage *sourceImage = [CIImage imageWithContentsOfURL:[NSURL fileURLWithPath:imagepath]];
    
    [sepiaFilter setDefaults];
    [sepiaFilter setValue:sourceImage forKey:@"inputImage"];
    
    CIImage *resultImage = [sepiaFilter valueForKey:@"outputImage"];
    
    [context drawImage:resultImage inRect:NSMakeRect(0, 0, 640, 480) fromRect:NSMakeRect(0, 0, 640, 480)];    
}

@end
