//
//  WeatherWindowController.m
//  WeatherApp
//
//  Created by Kevin Hoffman on 9/20/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "WeatherWindowController.h"

#define kApiKey @"-- CHANGE THIS TO YOUR API KEY --"

@implementation WeatherWindowController
@synthesize currentTemp, currentWind, currentZipCode, currentHumidity, currentCity, currentIcon,currentWeatherDescription;


NSMutableData *responseData;

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)awakeFromNib {
    self.currentCity = @"Nowhere, US";
    self.currentWind = @"";
    self.currentTemp = @"0F";
    self.currentHumidity = @"0%";
    self.currentWeatherDescription = @"Unknown";
}

- (void)windowDidLoad
{
    [super windowDidLoad];
    
    // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
}


- (IBAction)performWeatherLookup:(id)sender {
    NSLog(@"About to perform lookup on zip code %@", currentZipCode);
    responseData = [NSMutableData data];
    
    NSString *targetUrlString = 
    [NSString stringWithFormat:@"http://api.wunderground.com/api/%@/geolookup/conditions/q/%@.json",
     kApiKey, currentZipCode];
    NSMutableURLRequest *request = 
    [NSMutableURLRequest requestWithURL: [NSURL URLWithString:targetUrlString]];
    
    
    [request setValue:@"application/json" forHTTPHeaderField:@"Accept"];
    [request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
    [request setValue:@"STYOSXLionBookDemo" forHTTPHeaderField:@"User-Agent"];
    //    [request setValue:@"application/json" forKey:@"Content-Type"];
    [[NSURLConnection alloc] initWithRequest:request delegate:self];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    NSString *result = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
    NSError *error;
    NSDictionary *resultDict = (NSDictionary *)[NSJSONSerialization JSONObjectWithData:responseData options:NSJSONReadingMutableContainers error:&error];
    
    NSLog(@"results: %@", resultDict);
    NSDictionary *current_observation = [resultDict objectForKey:@"current_observation"];
    NSDictionary *current_location = [resultDict objectForKey:@"location"];
    
    // Set values
    self.currentCity = [NSString stringWithFormat:@"%@, %@",
                        (NSString *)[current_location objectForKey:@"city"],
                        (NSString *)[current_location objectForKey:@"state"]];
    NSNumber * tempF = [current_observation objectForKey:@"temp_f"];
    self.currentTemp = [NSString stringWithFormat:@"%@ F", [tempF stringValue]];
    
    NSString *icon_url = (NSString *)[current_observation objectForKey:@"icon_url"];
    self.currentIcon = [[NSImage alloc] initWithContentsOfURL:[NSURL URLWithString:icon_url]];
    self.currentHumidity = (NSString *)[current_observation objectForKey:@"relative_humidity"];
    self.currentWind = (NSString *)[current_observation objectForKey:@"wind_string"];
    self.currentWeatherDescription = (NSString *)[current_observation objectForKey:@"weather"];
    

    NSLog(@"%@", tempF);
    
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response  {
    [responseData setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    [responseData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    NSLog(@"Connection failed: %@", error);
}
@end
