//
//  DragDestinationView.m
//  Hour22
//
//  Created by Kevin Hoffman on 10/5/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "DragDestinationView.h"
#import "STYAppDelegate.h"

@implementation DragDestinationView

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)drawRect:(NSRect)dirtyRect
{
    // Drawing code here.
}

- (void)awakeFromNib
{
    NSLog(@"Registering for drag types...");
    [self registerForDraggedTypes:[NSArray arrayWithObject:kMyDragType]];
}


-(NSDragOperation)draggingEntered:(id<NSDraggingInfo>)sender
{
    NSLog(@"dragging entered (destination)");
    NSPasteboard *pb;
    NSDragOperation sourceDragMask;
    
    sourceDragMask = [sender draggingSourceOperationMask];
    pb = [sender draggingPasteboard];
    
    
    STYAppDelegate *appDelegate = (STYAppDelegate *)[[NSApplication sharedApplication] delegate];
    appDelegate.trashCanImage.image = [NSImage imageNamed:@"fullcan.png"];
    
    return NSDragOperationCopy | NSDragOperationMove;
}

- (void)draggingExited:(id<NSDraggingInfo>)sender
{
    STYAppDelegate *appDelegate = (STYAppDelegate *)[[NSApplication sharedApplication] delegate];
    appDelegate.trashCanImage.image = [NSImage imageNamed:@"emptycan.png"];
}

- (BOOL)performDragOperation:(id<NSDraggingInfo>)sender
{
    STYAppDelegate *appDelegate = (STYAppDelegate *)[[NSApplication sharedApplication] delegate];
    appDelegate.trashCanImage.image = [NSImage imageNamed:@"emptycan.png"];
    NSPasteboard *pb;
    NSDragOperation sourceDragMask;
    
    sourceDragMask = [sender draggingSourceOperationMask];
    pb = [sender draggingPasteboard];

    NSData *pbData = [pb dataForType:kMyDragType];
    NSString *customData = [[NSString alloc] initWithData:pbData encoding:NSUTF8StringEncoding];
    NSLog(@"received a drag operation: %@", customData);
    
    return YES;

}

@end
