//
//  STYAppDelegate.m
//  monstergrower
//
//  Created by Kevin Hoffman on 10/9/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "STYAppDelegate.h"
#import <StoreKit/StoreKit.h>

#define kProductYummies @"com.stylion.monstergrower3.inapp.yummies"
#define kProductPremium @"com.stylion.monstergrower3.inapp.pro"

@implementation STYAppDelegate

@synthesize window = _window;

NSMutableDictionary *_products;


- (void)applicationWillFinishLaunching:(NSNotification *)notification 
{
    NSURL *receiptUrl = [[NSBundle mainBundle] appStoreReceiptURL];
    if (![[NSFileManager defaultManager] fileExistsAtPath:[receiptUrl path]])
    {
        NSLog(@"did not have an app store receipt, exiting w/code 173.");
        exit(173);
    }  
    else {        
        NSAlert *alert = [[NSAlert alloc] init];
        [alert addButtonWithTitle:@"OK"];
        [alert setMessageText:@"Found a receipt in my bundle..."];
        [alert setAlertStyle:NSInformationalAlertStyle];
        [alert beginSheetModalForWindow:self.window modalDelegate:self didEndSelector:nil contextInfo:nil];
    }
    
    SKProductsRequest *request = [[SKProductsRequest alloc] initWithProductIdentifiers:
                                  [NSSet setWithArray:[NSArray arrayWithObjects:
                                                       kProductYummies,
                                                       kProductPremium,
                                                       nil]]];
    
    _products = [[NSMutableDictionary alloc] init];
    request.delegate = self;
    [request start];
}

- (void)productsRequest:(SKProductsRequest *)request 
     didReceiveResponse:(SKProductsResponse *)response
{
    NSLog(@"got product request response: %@", response);
    NSLog(@"products: %@ %ld", response.products, [response.products count]);
    for (SKProduct *prod in response.products) {
        [_products setValue:prod forKey:prod.productIdentifier];
        NSLog(@"product: %@ %@", prod.localizedTitle, prod.price);
    }
    NSLog(@"invalid IDs: %@", response.invalidProductIdentifiers);
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
    if (![SKPaymentQueue canMakePayments]) {
        NSLog(@"Store isn't available for this user... disable in-app purchases!");
    }
    
    [[SKPaymentQueue defaultQueue] addTransactionObserver:self];
}

- (IBAction)fetchProductInfo:(id)sender
{
    SKProductsRequest *request = [[SKProductsRequest alloc] initWithProductIdentifiers:
                                  [NSSet setWithArray:[NSArray arrayWithObjects:
                                                       @"com.stylion.monstergrower3.inapp.yummies", nil]]];
    request.delegate = self;
    [request start];
}

- (void)paymentQueue:(SKPaymentQueue *)queue
 updatedTransactions:(NSArray *)transactions {

    for (SKPaymentTransaction *transaction in transactions)
    {
        switch (transaction.transactionState)
        {
            case SKPaymentTransactionStatePurchased:
                [self completeTransaction:transaction];
                break;
            case SKPaymentTransactionStateFailed:
                [self failedTransaction:transaction];
                break;
            case SKPaymentTransactionStateRestored:
                [self restoreTransaction:transaction];
            default:
                break;
        }
    }
}

- (void) completeTransaction: (SKPaymentTransaction *)transaction
{
    [self recordTransaction: transaction];
    [self provideContent: transaction.payment.productIdentifier];
    // Remove the transaction from the payment queue.
    [[SKPaymentQueue defaultQueue] finishTransaction: transaction];
}

- (void)provideContent:(NSString *)productIdentifier {
    SKProduct *product = [_products valueForKey:productIdentifier];
    
    NSAlert *alert = [[NSAlert alloc] init];
    [alert addButtonWithTitle:@"OK"];
    [alert setMessageText:[NSString stringWithFormat:@"You've just purchased '%@', congratulations!!",
                           product.localizedTitle]];
    [alert setAlertStyle:NSInformationalAlertStyle];
    [alert beginSheetModalForWindow:self.window modalDelegate:self didEndSelector:nil contextInfo:nil];
}

- (void)recordTransaction:(SKPaymentTransaction *)transaction {
    // This is where you would record transaction in application-specific
    // state, e.g. enable whatever feature the user just bought
}

- (void)failedTransaction:(SKPaymentTransaction *)transaction {
    
}

- (void)restoreTransaction:(SKPaymentTransaction *)transaction {
    
}

- (void)paymentQueue:(SKPaymentQueue *)queue removedTransactions:(NSArray *)transactions {
    
}

- (void)paymentQueueRestoreCompletedTransactionsFinished:(SKPaymentQueue *)queue {
    
}


- (IBAction)buyYummies:(id)sender {
    if ([SKPaymentQueue canMakePayments]) {
        SKProduct *yummiesProduct = [_products valueForKey:kProductYummies];
        SKPayment *payment = [SKPayment paymentWithProduct:yummiesProduct];
        [[SKPaymentQueue defaultQueue] addPayment:payment];
    }
}

- (IBAction)upgradeToPremium:(id)sender {
}
@end
